import hashlib
import random
import string
import urllib.parse
import urllib.request, urllib.parse, urllib.error
import six

def gen_api_key(length=24):
    """Generate an api key for the user to use"""
    m = hashlib.sha256()
    word = ''

    for i in range(length):
        word += random.choice(string.ascii_letters)

    if (six.PY2):
      m.update(word)
    else:
      m.update(word.encode())

    return str(m.hexdigest()[:length])


def get_query_string(url):
    """
        Return query parameters as a dict from the specified URL.
    """
    return dict(urllib.parse.parse_qsl(urllib.parse.urlparse(url).query, True))

def force_ssl(url_str):
    url = urllib.parse.urlparse(url_str)

    return urllib.parse.urlunparse((
        "https",
        url.netloc,
        url.path,
        url.params,
        url.query,
        url.fragment
    ))


def clean_url(url, query={}, should_force_ssl=True):
    """ Gets the URL with new query string parameters """
    query = urllib.parse.urlencode(query)
    result = urllib.parse.urlparse(url)._replace(query=query)

    url = urllib.parse.urlunparse(result)

    if should_force_ssl:
        url = force_ssl(url)

    return url
